%define debug_package %{nil}

%define _version 5.0.3
%define _release 2
%define pyver 2.6
%define __description "Bacula is a set of Open Source, enterprise ready, computer programs that permit you (or the system administrator) to manage backup, recovery, and verification of computer data across a network of computers of different kinds."

Summary: Bacula - The Network Backup Solution
Name: bacula
Version: %{_version}
Release: %{_release}.el6
Group: System Environment/Daemons
License: GPL v2
Source0: http://www.prdownloads.sourceforge.net/bacula/%{name}-%{version}.tar.gz
Source1: depkgs-qt-28Jul09.tar.gz
BuildRoot: %{_tmppath}/%{name}-root
URL: http://www.bacula.org/
Vendor: The Bacula Team
Packager: %{_packager}
Requires: openssl >= 0.9.8e
Requires: libstdc++ >= 4.1.2
Requires: python >= %{pyver}
Requires: readline >= 5.1

BuildRequires: qt, qt-devel, tcp_wrappers-devel
BuildRequires: pkgconfig
BuildRequires: postgresql-devel >= 8.1
BuildRequires: mysql-devel >= 5.0
BuildRequires: sqlite-devel >= 3.3.6
BuildRequires: python-devel >= %{pyver}
BuildRequires: libacl-devel >= 2.2
BuildRequires: tcp_wrappers >= 7.6
BuildRequires: ncurses-devel >= 5.5
BuildRequires: readline-devel >= 5.1
BuildRequires: openssl-devel >= 0.9.8e

BuildRequires: gtk2-devel >= 2.10
BuildRequires: libgnomeui-devel >= 2.16
BuildRequires: libart_lgpl-devel >= 2.3
BuildRequires: libbonobo-devel >= 2.16
BuildRequires: libbonoboui-devel >= 2.16
BuildRequires: GConf2-devel >= 2.14
BuildRequires: freetype-devel >= 2.2

%description
%__description

%package postgresql
Summary: Bacula - Director
Group: System Environment/Daemons
Provides: bacula-dir, bacula-server
Requires: openssl >= 0.9.8e
Requires: libstdc++ >= 4.1.2
Requires: postgresql >= 8.1
Requires: python >= %{pyver}
Requires: bacula >= %{version}

%package mysql
Summary: Bacula - Director
Group: System Environment/Daemons
Provides: bacula-dir, bacula-server
Requires: openssl >= 0.9.8e
Requires: libstdc++ >= 4.1.2
Requires: mysql >= 5.0
Requires: python >= %{pyver}
Requires: bacula >= %{version}

%package sqlite
Summary: Bacula - Director
Group: System Environment/Daemons
Provides: bacula-dir, bacula-server
Requires: openssl >= 0.9.8e
Requires: libstdc++ >= 4.1.2
Requires: sqlite >= 3.3.6
Requires: python >= %{pyver}
Requires: bacula >= %{version}

%description postgresql
%__description

%description mysql
%__description

%description sqlite
%__description

%package client
Summary: Bacula - Client
Group: System Environment/Daemons
Provides: bacula-fd, bacula-client
Requires: openssl >= 0.9.8e
Requires: libstdc++ >= 4.1.2
Requires: python >= %{pyver}
Requires: bacula >= %{version}

%description client
%__description

%package storage
Summary: Bacula - Storage Daemon
Group: System Environment/Daemons 
Provides: bacula-sd, bacula-storage
Requires: openssl >= 0.9.8e
Requires: libstdc++ >= 4.1.2
Requires: python >= %{pyver}
Requires: bacula >= %{version}

%description storage
%__description

%package console
Summary: Bacula - Console GUIs
Group: System Environment/Daemons
Provides: bconsole
Requires: openssl >= 0.9.8e
Requires: libstdc++ >= 4.1.2
Requires: python >= %{pyver}
Requires: bacula >= %{version}

%description console
%__description

#%package console-qt
#Summary: Bacula - Console GUIs
#Group: System Environment/Daemons
#Provides: bat
#Requires: openssl >= 0.9.8e
#Requires: libstdc++ >= 4.1.2
#Requires: python >= %{pyver}
#Requires: bacula >= %{version}

#%description console-qt
#%__description

%prep
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf $RPM_BUILD_ROOT

%setup
#tar -xzf %{SOURCE1} 
#sed -i -e ' s# -silent# -silent -confirm-license#; ' depkgs-qt/configure-qt4
#make -C depkgs-qt/

%build
#cd depkgs-qt/
#source qt4-paths
#cd ..

%install
mkdir .bin
ln -s /usr/bin/qmake-qt4 .bin/qmake
export PATH=${PATH}:.bin

%configure \
        --prefix=%{_prefix} \
        --sysconfdir=/etc/bacula \
        --with-scriptdir=/etc/bacula/scripts \
        --enable-smartalloc \
        --mandir=%{_mandir} \
	    --with-python \
        --enable-lockmgr \
        --with-openssl \
        --enable-ipv6 \
        --enable-tray-monitor \
        --with-pic \
        --with-tcp-wrappers \
        --with-x \
        --enable-bat \
        --enable-build-dird=no \
        --enable-build-stored=yes \
        --enable-client-only \
        --with-working-dir=/var/bacula \
        --with-plugindir=/etc/bacula/plugins 

make 
make install DESTDIR=%{buildroot}

for db in postgresql mysql sqlite3 ; do 
%configure \
        --prefix=%{_prefix} \
        --sysconfdir=/etc/bacula \
        --with-scriptdir=/etc/bacula/scripts \
        --enable-smartalloc \
        --mandir=%{_mandir} \
        --with-python \
        --enable-lockmgr \
        --with-openssl \
        --enable-ipv6 \
        --enable-tray-monitor \
        --with-pic \
        --with-tcp-wrappers \
        --with-x \
        --with-${db} \
        --enable-build-dird=yes \
        --enable-build-stored=no \
        --with-working-dir=/var/bacula \
        --with-plugindir=/etc/bacula/plugins

for d in src src/lib src/findlib src/cats src/dird src/stored src/tools ; do make -C ${d} ; done 

[ -f src/dird/.libs/lt-bacula-dir ] && /usr/bin/install -D -m 0754 src/dird/.libs/lt-bacula-dir %{buildroot}%{_sbindir}/${db}-bacula-dir
[ -f src/dird/.libs/bacula-dir ] && /usr/bin/install -D -m 0754 src/dird/.libs/bacula-dir %{buildroot}%{_sbindir}/${db}-bacula-dir
[ -f src/stored/.libs/bscan ] && /usr/bin/install -D -m 0754 src/stored/.libs/bscan %{buildroot}%{_sbindir}/${db}-bscan
[ -f src/stored/.libs/btape ] && /usr/bin/install -D -m 0754 src/stored/.libs/btape %{buildroot}%{_sbindir}/${db}-btape
[ -f src/tools/.libs/dbcheck ] && /usr/bin/install -D -m 0754 src/tools/.libs/dbcheck %{buildroot}%{_sbindir}/${db}-dbcheck
/usr/bin/install -D -m 0754 src/cats/libbacsql.la %{buildroot}%{_libdir}
/usr/bin/install -D -m 0755 src/cats/.libs/libbacsql-%{version}.so %{buildroot}%{_libdir}/${db}-libbacsql-%{version}.so

for tool in bacula-sd bcopy bextract bls ; do
    if [ ! -f %{buildroot}%{_sbindir}/${tool} ] ; then 
	[ -f src/stored/${tool} ] && /usr/bin/install -D -m 0754 src/stored/${tool} %{buildroot}%{_sbindir}/${tool} 
	[ -f src/stored/.libs/${tool} ] && /usr/bin/install -D -m 0754 src/stored/.libs/${tool} %{buildroot}%{_sbindir}/${tool}
    fi
done 

for tool in bregex bsmtp bwild ; do
    [ ! -f %{buildroot}%{_sbindir}/${tool} ] && /usr/bin/install -D -m 0754 src/tools/${tool} %{buildroot}%{_sbindir}/${tool}
done 
[ ! -d %{buildroot}/%{_sysconfdir}/bacula/scripts/ ] && mkdir -p %{buildroot}/%{_sysconfdir}/bacula/scripts/
cp updatedb/*${db}* %{buildroot}/%{_sysconfdir}/bacula/scripts/
done

# install init scripts
[ ! -d %{buildroot}/etc/rc.d/init.d/ ] && mkdir %{buildroot}/etc/rc.d/init.d/ -p
install -m 0755 platforms/redhat/bacula-fd %{buildroot}%{_sysconfdir}/rc.d/init.d/
install -m 0755 platforms/redhat/bacula-sd %{buildroot}%{_sysconfdir}/rc.d/init.d/
install -m 0755 platforms/redhat/bacula-dir %{buildroot}%{_sysconfdir}/rc.d/init.d/
[ -d %{buildroot}%{_sysconfdir}/bacula ] || mkdir -p %{buildroot}%{_sysconfdir}/bacula
install -m 0640 src/dird/bacula-dir.conf %{buildroot}%{_sysconfdir}/bacula/bacula-dir.conf
install -m 0640 src/filed/bacula-fd.conf %{buildroot}%{_sysconfdir}/bacula/bacula-fd.conf
install -m 0640 src/stored/bacula-sd.conf %{buildroot}%{_sysconfdir}/bacula/bacula-sd.conf

# clean up gui documentation
rm -f %{buildroot}/%{_mandir}/man1/{bat,bacula-bwxconsole}*
# clean scripts directory
rm -f %{buildroot}/etc/bacula/*.{new,old}
rm -f %{buildroot}/%{_libdir}/libbacsql.la
rm -f %{buildroot}/%{_libdir}/libbacsql.so
rm -f %{buildroot}/%{_libdir}/libbacsql-%{version}.so

# create gnome data
mkdir -p %{buildroot}%{_datadir}/pixmaps %{buildroot}%{_datadir}/applications %{buildroot}%{_sysconfdir}/security/console.apps %{buildroot}%{_sysconfdir}/pam.d %{buildroot}%{_bindir}

cp -p scripts/bacula.png %{buildroot}%{_datadir}/pixmaps/bacula.png
cp -p scripts/bacula.desktop.gnome2.consolehelper %{buildroot}%{_datadir}/applications/bacula.desktop

mkdir -p %{buildroot}%{_sysconfdir}/bacula/scripts
cp src/win32/cats/*.sql %{buildroot}%{_sysconfdir}/bacula/scripts/

%pre
[ ! "$(/usr/bin/getent passwd bacula | cut -f1 -d':')" == 'bacula' ] && /usr/sbin/useradd -c 'Bacula' -d /var/bacula -s /bin/bash bacula || echo ""

%post client
if [ -x /sbin/chkconfig ] ; then
    /sbin/chkconfig --add bacula-fd 
    /sbin/chkconfig bacula-fd on 
fi
%postun client
if [ -x /sbin/chkconfig ] ; then
    /sbin/chkconfig bacula-fd off 2>&1 >/dev/null
    /sbin/chkconfig --del bacula-fd 2>&1 >/dev/null
    /sbin/service bacula-fd stop 2>&1 >/dev/null
fi

%post storage
if [ -x /sbin/chkconfig ] ; then
    /sbin/chkconfig --add bacula-sd
    /sbin/chkconfig bacula-sd on 
fi
%postun storage
if [ -x /sbin/chkconfig ] ; then
    /sbin/chkconfig bacula-sd off 2>&1 >/dev/null
    /sbin/chkconfig --del bacula-sd 2>&1 >/dev/null
    /sbin/service bacula-sd stop  2>&1 >/dev/null
fi

%post postgresql
if [ -x /sbin/chkconfig ] ; then
    /sbin/chkconfig --add bacula-dir
    /sbin/chkconfig bacula-dir on 
fi
[ ! -L %{_libdir}/libbacsql-%{version}.so ] && ln -s %{_libdir}/postgresql-libbacsql-%{version}.so %{_libdir}/libbacsql-%{version}.so
[ ! -L %{_sbindir}/bscan ]  && ln -s %{_sbindir}/postgresql-bscan %{_sbindir}/bscan
[ ! -L %{_sbindir}/btape ]  && ln -s %{_sbindir}/postgresql-btape %{_sbindir}/btape
[ ! -L %{_sbindir}/bacula-dir ]  && ln -s %{_sbindir}/postgresql-bacula-dir %{_sbindir}/bacula-dir

%postun postgresql
if [ -x /sbin/chkconfig ] ; then
    /sbin/chkconfig bacula-dir off >/dev/null 2>&1
    /sbin/chkconfig --del bacula-dir >/dev/null 2>&1 
    /sbin/service bacula-dir stop
    echo ""
fi
[ -L %{_libdir}/libbacsql-%{version}.so ] && rm -f %{_libdir}/libbacsql-%{version}.so
[ -L %{_sbindir}/bacula-dir ] && rm -f %{_sbindir}/bacula-dir

%post mysql
if [ -x /sbin/chkconfig ] ; then
    /sbin/chkconfig --add bacula-dir
    /sbin/chkconfig bacula-dir on
fi
[ ! -L %{_libdir}/libbacsql-%{version}.so ] && ln -s %{_libdir}/mysql-libbacsql-%{version}.so %{_libdir}/libbacsql-%{version}.so
[ ! -L %{_sbindir}/bscan ]  && ln -s %{_sbindir}/mysql-bscan %{_sbindir}/bscan
[ ! -L %{_sbindir}/btape ]  && ln -s %{_sbindir}/mysql-btape %{_sbindir}/btape
[ ! -L %{_sbindir}/bacula-dir ]  && ln -s %{_sbindir}/mysql-bacula-dir %{_sbindir}/bacula-dir

%postun mysql
if [ -x /sbin/chkconfig ] ; then
    /sbin/chkconfig bacula-dir off >/dev/null 2>&1
    /sbin/chkconfig --del bacula-dir >/dev/null 2>&1
    /sbin/service bacula-dir stop
    echo ""
fi
[ -L %{_libdir}/libbacsql-%{version}.so ] && rm -f %{_libdir}/libbacsql-%{version}.so
[ -L %{_sbindir}/bacula-dir ] && rm -f %{_sbindir}/bacula-dir

%post sqlite
if [ -x /sbin/chkconfig ] ; then
    /sbin/chkconfig --add bacula-dir
    /sbin/chkconfig bacula-dir on
fi
[ ! -L %{_libdir}/libbacsql-%{version}.so ] && ln -s %{_libdir}/sqlite3-libbacsql-%{version}.so %{_libdir}/libbacsql-%{version}.so
[ ! -L %{_sbindir}/bscan ]  && ln -s %{_sbindir}/sqlite-bscan %{_sbindir}/bscan
[ ! -L %{_sbindir}/btape ]  && ln -s %{_sbindir}/sqlite-btape %{_sbindir}/btape
[ ! -L %{_sbindir}/bacula-dir ]  && ln -s %{_sbindir}/sqlite-bacula-dir %{_sbindir}/bacula-dir

%postun sqlite
if [ -x /sbin/chkconfig ] ; then
    /sbin/chkconfig bacula-dir off >/dev/null 2>&1
    /sbin/chkconfig --del bacula-dir >/dev/null 2>&1
    /sbin/service bacula-dir stop
    echo ""
fi
[ -L %{_libdir}/libbacsql-%{version}.so ] && rm -f %{_libdir}/libbacsql-%{version}.so
[ -L %{_sbindir}/bacula-dir ] && rm -f %{_sbindir}/bacula-dir

%files
%defattr(-, root, root)
%{_sysconfdir}/bacula/scripts/*
%{_datadir}/doc
%{_mandir}/man1/bsmtp*
%{_libdir}/libbacpy.la
%{_libdir}/libbac.la
%{_libdir}/libbac-%{version}.so
%{_libdir}/libbaccfg-%{version}.so
%{_libdir}/libbacfind-%{version}.so
%{_libdir}/libbacpy-%{version}.so
%{_libdir}/libbac.so
%{_libdir}/libbaccfg.la
%{_libdir}/libbaccfg.so
%{_libdir}/libbacfind.la
%{_libdir}/libbacfind.so
%{_libdir}/libbacpy.so
%attr(-, bacula, bacula) %dir %{_var}/bacula
%{_sbindir}/bacula
%{_sbindir}/bcopy
%{_sbindir}/bextract
%{_sbindir}/bls
%{_sbindir}/bregex
%{_sbindir}/bsmtp
%{_sbindir}/btraceback
%{_sbindir}/bwild
%{_mandir}/man8/bacula*
%{_mandir}/man8/bcopy*
%{_mandir}/man8/bextract*
%{_mandir}/man8/bls*
%{_mandir}/man8/btraceback*

%files postgresql
%defattr(-, root, root)
%{_libdir}/postgresql-libbacsql-%{version}.so
%{_sbindir}/postgresql-bacula-dir
%{_sbindir}/postgresql-bscan
%{_sbindir}/postgresql-btape
%{_sbindir}/postgresql-dbcheck
%config(noreplace) %{_sysconfdir}/bacula/bacula-dir.conf
%{_sysconfdir}/rc.d/init.d/bacula-dir
%{_sysconfdir}/bacula/scripts/*postgresql*.sql
%{_mandir}/man8/dbcheck.8.gz
%{_mandir}/man8/bscan*
%{_mandir}/man8/btape*

%files mysql
%defattr(-, root, root)
%{_libdir}/mysql-libbacsql-%{version}.so
%{_sbindir}/mysql-bacula-dir
%{_sbindir}/mysql-bscan
%{_sbindir}/mysql-btape
%{_sbindir}/mysql-dbcheck
%config(noreplace) %{_sysconfdir}/bacula/bacula-dir.conf
%{_sysconfdir}/rc.d/init.d/bacula-dir
%{_sysconfdir}/bacula/scripts/*mysql*.sql
%{_mandir}/man8/dbcheck.8.gz
%{_mandir}/man8/bscan*
%{_mandir}/man8/btape*

%files sqlite
%defattr(-, root, root)
%{_libdir}/sqlite3-libbacsql-%{version}.so
%{_sbindir}/sqlite3-bacula-dir
%{_sbindir}/sqlite3-bscan
%{_sbindir}/sqlite3-btape
%{_sbindir}/sqlite3-dbcheck
%config(noreplace) %{_sysconfdir}/bacula/bacula-dir.conf
%{_sysconfdir}/rc.d/init.d/bacula-dir
%{_sysconfdir}/bacula/scripts/*sqlite3*.sql
%{_mandir}/man8/dbcheck.8.gz
%{_mandir}/man8/bscan*
%{_mandir}/man8/btape*

%files client
%defattr(-, root, root)
%config(noreplace) %{_sysconfdir}/bacula/bacula-fd.conf
%{_sysconfdir}/rc.d/init.d/bacula-fd
%{_sbindir}/bacula-fd
%{_sysconfdir}/bacula/plugins/bpipe-fd.so
%{_mandir}/man8/bacula-fd.8.gz

%files storage
%defattr(-, root, root)
%config(noreplace) %{_sysconfdir}/bacula/bacula-sd.conf
%{_sysconfdir}/rc.d/init.d/bacula-sd
%{_sbindir}/bacula-sd
%{_mandir}/man8/bacula-sd.8.gz

%files console
%defattr(-, root, root)
%config(noreplace) %{_sysconfdir}/bacula/tray-monitor.conf
%config(noreplace) %{_sysconfdir}/bacula/bconsole.conf
%{_sbindir}/bconsole
%{_sbindir}/bacula-tray-monitor
%{_mandir}/man1/bacula-tray-monitor*
%{_mandir}/man8/bconsole*
%{_datadir}/pixmaps/bacula.png
%{_datadir}/applications/bacula.desktop


#%files console-qt
#%defattr(-, root, root)
#%config(noreplace) %{_sysconfdir}/bacula/bat.conf
#%{_sbindir}/bat
#%{_datadir}/doc/bacula/*
